package com.dragonsoft.dcuc.approvegateway.controller;

import com.dragonsoft.approve.common.HttpCode;
import com.dragonsoft.duceap.base.entity.http.ResponseStatus;
import com.dragonsoft.duceap.base.exception.ApplicationException;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

/**
 * @Author: qiuyu
 * @Date: 2021/1/15 14:15
 * @Description:
 */
@RestController
public class ApproveErrorController {

    @GetMapping(value = "/error")
    public ResponseEntity<ResponseStatus> error(HttpServletRequest request) {
        Object attribute = request.getAttribute("javax.servlet.error.exception");
        Throwable throwable = (Throwable) attribute;

        if (throwable != null) {
            if (throwable.getCause() instanceof ApplicationException) {
                ApplicationException ex = (ApplicationException) throwable.getCause();
                int status = ex.getStatusCode() == 0 ? 500 : ex.getStatusCode();
                assert HttpStatus.resolve(HttpCode.PARAM_VERIFY_ERROR.getCode()) != null;
                return new ResponseEntity<>(new ResponseStatus(String.valueOf(status), ex.getMessage()), HttpStatus.resolve(HttpCode.PARAM_VERIFY_ERROR.getCode()));
            } else {
                return new ResponseEntity<>(ResponseStatus.fail("500", "未知异常[" + throwable.getMessage() + "]"), HttpStatus.BAD_GATEWAY);
            }
        } else {
            return new ResponseEntity<>(ResponseStatus.fail("500", "未知异常"), HttpStatus.BAD_GATEWAY);
        }


    }
}
