package com.dragonsoft.dcuc.approvegateway.controller;

import com.dragonsoft.dcuc.client.logout.DcucLogoutHandler;
import com.dragonsoft.dids.client.utils.PropUtils;
import com.dragonsoft.duceap.base.entity.http.ResponseLink;
import com.dragonsoft.duceap.commons.util.string.StringUtils;
import com.dragonsoft.duceap.security.dcuc.DcucProperties;
import com.dragonsoft.duceap.security.dids.DidsProperties;
import com.dragonsoft.duceap.web.SecurityProperties;
import com.dragonsoft.duceap.web.utils.RequestUtils;
import com.dragonsoft.duceap.web.utils.ResponseUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.net.URLEncoder;

/**
 * @author lidr
 * @date 2021/2/24
 */
@RestController
public class ApproveLoginController {
    @Autowired(required = false)
    private DidsProperties didsProperties;
    @Autowired(required = false)
    private DcucProperties dcucProperties;
    @Autowired
    SecurityProperties securityProperties;

    @RequestMapping({"/gateway/logout"})
    public void logout(HttpServletRequest request, HttpServletResponse response) throws Exception {
        String type = securityProperties.getType();
        if (type.equalsIgnoreCase("dcuc")) {
            String redirectUrl = request.getParameter("redirectUrl") != null ? request.getParameter("redirectUrl") : this.dcucProperties.getServerName();
            String logoutUrl = this.dcucProperties.getCasServerUrlPrefix() + "/logout?service=" + URLEncoder.encode(redirectUrl, "UTF-8");
            ResponseLink responseLink = ResponseLink.logout(logoutUrl);
            if (RequestUtils.isXmlHttpRequest(request)) {
                request.getSession().invalidate();
                ResponseUtils.outJson(responseLink, response);
            } else {
                DcucLogoutHandler.logout(request, response, redirectUrl);
            }
        } else {
            String ssoUrl = PropUtils.getInstance().getConfigItem("dids2.SSOLoginUrl").replace("/login", "");
            String redirectUrl = StringUtils.defaultIfEmpty(request.getParameter("redirectUrl"), StringUtils.substringBeforeLast(this.didsProperties.getSSOServiceUrl(), "/login"));
            String logoutUrl = ssoUrl + "/logout?service=" + redirectUrl;
            ResponseLink responseLink = ResponseLink.logout(logoutUrl);
            if (RequestUtils.isXmlHttpRequest(request)) {
                request.getSession().invalidate();
                ResponseUtils.outJson(responseLink, response);
            } else {
                request.getSession().invalidate();
                response.sendRedirect(logoutUrl);
            }
        }
    }
}
