package com.dragonsoft.dcuc.approvegateway.properties;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * <p>
 * 审批配置
 * </p>
 *
 * @author huangzqa
 * @date 2021/6/21
 */
@Data
@ConfigurationProperties(prefix = "dcuc.approve")
@Component
public class DcucApproveProperties {

    /**
     * 竹云认证地址
     */
    private String bimIdentityUrl;

    /**
     * 竹云应用方标识
     */
    private String bimLoginId;

    /**
     * 竹云应用方秘钥
     */
    private String bimSecretKey;

    /**
     * 竹云 token 失效时间（单位秒）
     */
    private Integer bimTokenExpireSecond = 9 * 60;

    /**
     * 华为登陆过滤路径
     */
    private String huaweiLoginFilterUrl = "";

}
